/* Rotaciona um cubo com esferas nos vertices - apenas 320x200.
 Usa paginas de video (matriz na memoria RAM) para compor a imagem. */

#include <conio.h>        // getch e clrscr
#include <math.h>         // sqrt
#include <iostream.h>     // cout e cin
#include <stdlib.h>       // alocacao de memoria
#include <stdarg.h>       // va_list, va_start, va_arg, va_end
#include <dos.h>          // geninterrupt e delay


#define RAIO_ORIG 24      // !!! RAIO soh pode ser ate 50 !!!
#define N_VERTICES 8
#define MAXCONTA 20       // Valor maximo dos contadores de incremento dos angulos de rotacao
#define INCANG 3
#define MEMALOCAR 40000


int
	RAIO,                 // raio que a esfera tera, depende do modo de video
	CENTROX = 160,         // coordenadas na tela do centro do cubo
	CENTROY = 50,
	XO [ N_VERTICES ] = {-50, 50, 50, -50, -50, 50, 50, -50},  // a figura eh
	YO [ N_VERTICES ] = {-50, 50, 50, 50, 50, -50, -50, -50},  // definida
	ZO [ N_VERTICES ] = {-50, 50, -50, -50, 50, -50, 50, 50},  // globalmente.
	XR [ N_VERTICES ],    // XO, YO, ZO tem os valores originais das
	YR [ N_VERTICES ],    // coordenadas dos vetices do desenho. XR, YR, ZR
	ZR [ N_VERTICES ],    // tem os valores que sao obtidos opos uma rotacao.
	X2D [ N_VERTICES ],   // X2D e Y2D tem os valores dos vertices projetados.
	Y2D [ N_VERTICES ],
	Ja_Ordenados [N_VERTICES];  // define os vertices desenhados (usado na ordenacao).

unsigned char
	*Prt_MEMVGA = (unsigned char *) MK_FP (0xA000, 0),    // inicio da mem. de video
	*Prt_PgVirtual,
	Mat_Desenho [100] [100];         // guarda esfera para o modo 320x200

float
	ESCALA;               // Para manter o mesmo raio visualmente, mesmo variando a resolucao.

long
	Sen [ 360 ],          // afim de tornar o programa mais rapido: sao
	Cos [ 360 ];          // precalculados os valores dos senos e cossenos e



/* Eleva um numero ao quadrado
****************************************************************************/
inline int Quadrado ( int N )
{
	return ( N * N );
}



/* Calcula o valor cuja raiz quadrada sera extraida. Para CalcZ.
****************************************************************************/
inline int Delta ( int X, int Y )
{
	return ( Quadrado ( RAIO ) - Quadrado ( X ) - Quadrado ( Y ) );
}



/* Calcula o valor de Z em cada ponto da esfera.
****************************************************************************/
inline int CalcZ ( int X, int Y )
{
	return ( sqrt ( Delta ( X, Y ) ) );
}



/* Espera retraco vectical para desenhar
****************************************************************************/
void WaitRetrace ()
{
	_DX = 0x03DA;

	l1: asm {
		in  al,dx;
		and al,0x08;
		jnz l1;
		}

	l2: asm {
		in  al,dx;
		and al,0x08;
		jz  l2;
		}
}



/* Inicializa a memoria de video virtual (zera).
****************************************************************************/
void Zera_PgVirtual ()
{
	memset ( Prt_PgVirtual, 0, MEMALOCAR );
}



/* Marca um ponto diretamente na memoria grafica (para 320x200).
****************************************************************************/
inline void MEMputpixel ( int X, int Y, unsigned char Cor, unsigned char *Dedo)
{
	memset (Dedo + X + ( Y * 320 ), Cor, 1);
}



/* Altera um registrador de cor (para 320x200), setando diretamente as portas
****************************************************************************/
inline void MEMsetrgbpalette (unsigned char NumReg,
										unsigned char R,
										unsigned char G,
										unsigned char B)
{
  outp ( 0x03C8, NumReg );
  outp ( 0x03C9, R );
  outp ( 0x03C9, G );
  outp ( 0x03C9, B );
}



/* Define qual a resolucao que sera usada, aloca memoria.
****************************************************************************/
void Inicializa_Gr ()
{
	Prt_PgVirtual = (unsigned char *) malloc ( MEMALOCAR );

	if ( Prt_PgVirtual == NULL )
		{
			cout << "\nMemoria insuficiente.";
			exit (1);
		}

	Zera_PgVirtual ();

	clrscr ();

	cout << "O modo de video eh o MCGA (320x200x256).\n\n";
	cout << "\n\n\n" << "Instrucoes para controle gradual:\n";
	cout << " Q  e  W  -  incrementam/decrementam a taxa de rotacao do angulo alfa.\n";
	cout << " A  e  S  -  incrementam/decrementam a taxa de rotacao do angulo beta.\n";
	cout << " Z  e  X  -  incrementam/decrementam a taxa de rotacao do angulo teta.\n";
	cout << " E, D, C  -  passam para zero a taxa de rotacao de cada um dos tres angulos.\n";
	cout << " R, F, V  -  passam para o maximo a taxa de rotacao de cada um dos angulos.\n";
	cout << "\n ESC      - sai.";
	cout << "\nAtencao: CAPS LOCK deve estar desativado!!\n";

	getch ();

	_AX = 0x0013;            // Chama interrupcao que inicia modo
	geninterrupt (0x10);     // grafico 320x200x256.

	ESCALA = 0.4583333;
	RAIO = ( int ) RAIO_ORIG * ESCALA;
}



/* Termina o modo grafico, voltando ao modo de texto e desaloca memoria.
****************************************************************************/
void Finaliza_Gr ( )
{
	_AX = 0x0003;
	geninterrupt (0x10);
	free (Prt_PgVirtual);
}



/* Muda os registradores de cor de 64 a 128, carregando 64 tons de G/2+B.
	E carrega tons de cinza esbranquicado de 128 a 135.
****************************************************************************/
void Altera_Palheta ()
{
	for ( int Conta = 0; Conta < 64; Conta ++ )
		MEMsetrgbpalette (Conta + 64, 0, (64 - Conta) / 2, 64 - Conta);

	MEMsetrgbpalette ( 139, 30, 30, 30 );
	MEMsetrgbpalette ( 138, 38, 38, 38 );
	MEMsetrgbpalette ( 137, 46, 46, 46 );
	MEMsetrgbpalette ( 136, 46, 46, 46 );
	MEMsetrgbpalette ( 135, 46, 46, 46 );
	MEMsetrgbpalette ( 134, 52, 52, 52 );
	MEMsetrgbpalette ( 133, 52, 52, 52 );
	MEMsetrgbpalette ( 132, 52, 52, 52 );
	MEMsetrgbpalette ( 131, 63, 63, 63 );
	MEMsetrgbpalette ( 130, 63, 63, 63 );
	MEMsetrgbpalette ( 129, 63, 63, 63 );
	MEMsetrgbpalette ( 128, 63, 63, 63 );
}



/* Renderiza, faz o desenho de uma esfera no meio da tela.
****************************************************************************/
void Faz_Esfera ()
{
	int
		ContaX,
		ContaY,
		Cor,
		CVetN_X,            // componentes do vetor normal ao plano tangente
		CVetN_Y,            // a um ponto da esfera.
		CVetN_Z,
		CVetL_X = -25,      // componentes do vetor da fonte luminosa.
		CVetL_Y = 15,
		CVetL_Z = 65,
		ProdEsc;            // produto escalar: a*c + b*d  para  (a,b) * (c,d)
	float
		ModuloVetN,         // comprimento do vetor normal (= ao raio).
		ModuloVetL = ( float ) sqrt ( Quadrado (CVetL_X) + Quadrado (CVetL_Y) + Quadrado (CVetL_Z) ),
		Angulo;             // angulo entre os vetores. Para definir brilho.

	for ( ContaY = -RAIO; ContaY < RAIO; ContaY ++ )   // Varre a area da tela
		for ( ContaX = -RAIO; ContaX < RAIO; ContaX ++ )   // em que a esfera
			if ( Delta ( ContaX, ContaY ) >= 0 )            // vai aparecer.
				{
					CVetN_X = ContaX;
					CVetN_Y = ContaY;
					CVetN_Z = CalcZ ( ContaX, ContaY );
					ModuloVetN = ( float ) sqrt ( Quadrado (CVetN_X) + Quadrado (CVetN_Y) + Quadrado (CVetN_Z) );
					ProdEsc = CVetN_X * CVetL_X + CVetN_Y * CVetL_Y + CVetN_Z * CVetL_Z;
					Angulo = ( int ) ( acos ( ( float ) ProdEsc / ( ModuloVetN * ModuloVetL ) ) * 180 / M_PI );
					Cor = 64 + ( int ) Angulo / 3 + 16;
					MEMputpixel ( ContaX + CENTROX, ContaY + CENTROY, Cor, Prt_MEMVGA );
					if ( Angulo <= 7 )
						MEMputpixel ( ContaX + CENTROX, ContaY + CENTROY, 128 + Angulo, Prt_MEMVGA );
				}
}



/* Salva (captura) a esfera e a apaga (para 320x200). Usa Mat_Desenho.
****************************************************************************/
void MEMCaptura ()
{
	unsigned char
		*Prt_Byte;
	int
		ContaX;

	for ( int ContaY = 0; ContaY < (2 * RAIO) + 1; ContaY ++ )   // = getimage
		{
			Prt_Byte = (unsigned char *) MK_FP (0xA000, CENTROX - RAIO + 320 * ( ContaY + CENTROY - RAIO ) );
			for ( ContaX = 0; ContaX < (2 * RAIO) + 1; ContaX ++ )
				{
					Mat_Desenho [ContaX] [ContaY] = *Prt_Byte;
					Prt_Byte ++;
				}
		}

	getch ();

	for ( ContaY = 0; ContaY < (2 * RAIO) + 1; ContaY ++ )       // apaga
		for ( ContaX = 0; ContaX < (2 * RAIO) + 1; ContaX ++ )
			MEMputpixel (ContaX + 160 - RAIO, ContaY + 100 - RAIO, 0, Prt_MEMVGA );
}



/* Calcula senos e cossenos de 0 a 359 graus.
	Como eh mais rapido calcular valores inteiros, o resultado do seno e do
	cosseno eh quardado numa matriz de inteiros (longos = 4 bytes) como um
	numero inteiro. Apos o calculo da rotacao eh feita devida a conversao para
	fracionario. Ha uma pequena perda de precisao, pois a parte fracionaria
	que foi obtida no calculo eh perdida (o numero eh truncado).
	Tambem faz correcao nas distancias dos vertices do cubo.
****************************************************************************/
void Pre_Calcula ()
{
	for ( int Graus = 0; Graus < 360; Graus ++ )
		{
			Sen [ Graus ] = ( long ) ( sin ( Graus * M_PI / 180 ) * 65536 );
			Cos [ Graus ] = ( long ) ( cos ( Graus * M_PI / 180 ) * 65536 );
		}
	for ( int Conta = 0; Conta < N_VERTICES; Conta ++ )
		{                                        // Ajusta as coordenadas dos
			XO [ Conta ] *= ESCALA;               // vertices a escala definida
			YO [ Conta ] *= ESCALA;               // pelo modo grafico
			ZO [ Conta ] *= ESCALA;               // selecionado.
		}
}



/* Calcula as novas coordenadas da figura, no espaco, segundo um
  certo angulo de rotacao em cada eixo por meio de uma matriz de rotacao.
****************************************************************************/
void Rotaciona ( int Alfa, int Beta, int Teta )
{
	int
		XAux, YAux, ZAux;
	for ( int Conta = 0; Conta < N_VERTICES; Conta ++ )
		{
			XR [ Conta ] = XO [ Conta ];
			YR [ Conta ] = YO [ Conta ];
			ZR [ Conta ] = ZO [ Conta ];
			XAux = ( XR [Conta] * Cos [Alfa] >> 16 ) + ( YR [Conta] * Sen [Alfa] >> 16 );
			YAux = ( YR [Conta] * Cos [Alfa] >> 16 ) - ( XR [Conta] * Sen [Alfa] >> 16 );
			YR [Conta] = ( YAux * Cos [Beta] >> 16 ) + ( ZR [Conta] * Sen [Beta] >> 16 );
			ZAux = ( ZR [Conta] * Cos [Beta] >> 16 ) - ( YAux * Sen [Beta] >> 16 );
			XR [Conta] = ( XAux * Cos [Teta] >> 16 ) + ( ZAux * Sen [Teta] >> 16 );
			ZR [Conta] = ( ZAux * Cos [Teta] >> 16 ) - ( XAux * Sen [Teta] >> 16 );
		}
}



/* Faz a projecao dos pontos em 3D, com perspectiva, para a tela.
	E desloca os pontos para o centro da tela.
	A divisao por Z cria a ideia de que a tela tem profundidade. No caso o
	"ponto de fuga", esta no centro da tela.
***************************************************************************/
void Projeta ( int Distancia, int Perspectiva )
{
	for ( int Conta = 0; Conta < N_VERTICES; Conta ++ )
		{
			X2D [ Conta ] = ( int ) ( ( long ) XR [ Conta ] * Perspectiva / ( ZR [ Conta ] + Perspectiva - Distancia ) ) + CENTROX;
			Y2D [ Conta ] = ( int ) ( ( long ) YR [ Conta ] * Perspectiva / ( ZR [ Conta ] + Perspectiva - Distancia ) ) + CENTROY;
		}
}



/* Desenha os vertices da figura na tela.
****************************************************************************/
void Desenha ( int Marcar ... )
{
	if ( Marcar )               // se Marcar = 1 projetar e desenhar colorido
		{
			va_list Lista_Param;               // extrai parametros extra
			va_start ( Lista_Param, Marcar );
			int
				Distancia = va_arg (Lista_Param, int),
				Perspectiva = va_arg (Lista_Param, int);
			va_end (Lista_Param);
			Projeta ( Distancia, Perspectiva );  // faz o efeito de perspertiva
		}

	int
		Menor,            // menor numero dentre os que nao foram passados
		Ind_MaiorMenor,   // indice do maior numero dentre os menores que jah foram passados
		ContaX,
		ContaY,
		Conta_Menor,
		Conta_Vetor;

	unsigned char
		*Prt_Byte;

	for ( Conta_Vetor = 0; Conta_Vetor < N_VERTICES; Conta_Vetor ++ )   // zera vetor
		Ja_Ordenados [Conta_Vetor] = 0;

	// os vertices sao desenhados na ordem do fundo para a frente
	for ( Conta_Vetor = 0; Conta_Vetor < N_VERTICES; Conta_Vetor ++ )
		{

			// Para definir qual eh o vertice que esta mais atras.
			Menor = -32768;
			for ( Conta_Menor = 0; Conta_Menor < N_VERTICES; Conta_Menor ++ )
				if ( ( ZR [Conta_Menor] >= Menor ) && ( Ja_Ordenados [Conta_Menor] == 0 ) )
					{
						Menor = ZR [Conta_Menor];
						Ind_MaiorMenor = Conta_Menor;
					}

			if ( Marcar )                           // poe a esfera (320x200)
				for ( ContaY = 0; ContaY < (2 * RAIO) + 1; ContaY ++ )
					for ( ContaX = 0; ContaX < (2 * RAIO) + 1; ContaX ++)
						MEMputpixel ( X2D [Ind_MaiorMenor] + ContaX, Y2D [Ind_MaiorMenor] + ContaY, Mat_Desenho [ContaX] [ContaY], Prt_PgVirtual );

			Ja_Ordenados [Ind_MaiorMenor] = 1;
		}

	 // copia pagina virtual para a memoria de video
	memcpy (Prt_MEMVGA, Prt_PgVirtual, MEMALOCAR );
}



/* Verifica se os angulos de rotacao estao dentro da faixa de 0 a 359
****************************************************************************/
void Testa_Angulos ( int &Alfa, int &Beta, int &Teta )
{
	Alfa = Alfa % 360;       // calcula o modulo
	Beta = Beta % 360;
	Teta = Teta % 360;
	if ( Alfa < 0 ) Alfa = 360 - INCANG;    // reflete o valor se for negativo
	if ( Beta < 0 ) Beta = 360 - INCANG;
	if ( Teta < 0 ) Teta = 360 - INCANG;
}



/* Faz a coordenacao do programa. Loop principal.
****************************************************************************/
void Kernel ()
{
	char
		Tecla;
	int
		Alfa = 0,        // valores iniciais dos angulos de rotacao
		Beta = 0,
		Teta = 0,
		IncR_Alfa = 0,    // Taxa de incremento do contador de defermina quando
		IncR_Beta = 0,    // serah deita rotacao num eixo.
		IncR_Teta = 10,
		Conta_Alfa = 0,   // Conta interacoes ateh ser igual ao numero do
		Conta_Beta = 0,   // periodo (IncR_xxxx) e entao faz uma rotacao.
		Conta_Teta = 0;

	while ( Tecla != 27 )            // se for pressionado ESC sai
		{
			while ( !kbhit () )
				{
					Desenha ( 0 );
					Testa_Angulos ( Alfa, Beta, Teta );
					Rotaciona ( Alfa, Beta, Teta );
					Desenha ( 1, 50, 300 );
					Conta_Alfa += IncR_Alfa;
					Conta_Beta += IncR_Beta;
					Conta_Teta += IncR_Teta;
					if ( Conta_Alfa > MAXCONTA )
						{
							Conta_Alfa = 0;
							Alfa += INCANG;
						}
					else
						if ( Conta_Alfa < -MAXCONTA )
							{
								Conta_Alfa = 0;
								Alfa -= INCANG;
							}
					if ( Conta_Beta > MAXCONTA )
						{
							Conta_Beta = 0;
							Beta += INCANG;
						}
					else
						if ( Conta_Beta < -MAXCONTA )
							{
								Conta_Beta = 0;
								Beta -= INCANG;
							}
					if ( Conta_Teta > MAXCONTA )
						{
							Conta_Teta = 0;
							Teta += INCANG;
						}
					else
						if ( Conta_Teta < -MAXCONTA )
							{
								Conta_Teta = 0;
								Teta -= INCANG;
							}
				}
			Tecla = getch ();
			if ( Tecla == 'e' ) IncR_Alfa = 0;           // Setam e resetam
			if ( Tecla == 'r' ) IncR_Alfa = MAXCONTA;    // os contadores.
			if ( Tecla == 'd' ) IncR_Beta = 0;
			if ( Tecla == 'f' ) IncR_Beta = MAXCONTA;
			if ( Tecla == 'c' ) IncR_Teta = 0;
			if ( Tecla == 'v' ) IncR_Teta = MAXCONTA;
			if ( ( Tecla == 'q' ) && ( IncR_Alfa < MAXCONTA ) ) IncR_Alfa += 1;
			if ( ( Tecla == 'w' ) && ( IncR_Alfa > -MAXCONTA ) ) IncR_Alfa -= 1;
			if ( ( Tecla == 'a' ) && ( IncR_Beta < MAXCONTA ) ) IncR_Beta += 1;
			if ( ( Tecla == 's' ) && ( IncR_Beta > -MAXCONTA ) ) IncR_Beta -= 1;
			if ( ( Tecla == 'z' ) && ( IncR_Teta < MAXCONTA ) ) IncR_Teta += 1;
			if ( ( Tecla == 'x' ) && ( IncR_Teta > -MAXCONTA ) ) IncR_Teta -= 1;
		}
}



main ()
{
	Inicializa_Gr ();

	Altera_Palheta ();

	Faz_Esfera ();

	MEMCaptura ( );

	Pre_Calcula ();

	Kernel ( );

	Finaliza_Gr ();
}